# Name :          Desel 1.o
# Description :   select only edges/faces and add/remove faces from a selection
# Author :        TBD
# Web:            http://su.plugins.ro
# Usage :         make selection, use Plugins|[TBD] Desel options
# Date :          13.Aug.2oo4
# Type :          select tool
# History:        1.0 (13.Aug.2oo4) - first version

def desel_func what
   Sketchup.active_model.start_operation "Desel"

   ss = Sketchup.active_model.selection
   to_remove = []
   0.upto(ss.length) do |counter|
      to_remove.push(ss[counter]) if(ss[counter].class == what)
   end
   to_remove.each {|e| ss.remove(e)}

   Sketchup.active_model.commit_operation
end

def add_faces
   Sketchup.active_model.start_operation "Desel | Add faces"

   ss = Sketchup.active_model.selection
   0.upto(ss.length) do |counter|
      ss[counter].find_faces if(ss[counter].class == Sketchup::Edge)
   end

   Sketchup.active_model.commit_operation
end

def remove_faces
   Sketchup.active_model.start_operation "Desel | Remove faces"

   ss = Sketchup.active_model.selection
   0.upto(ss.length) do |counter|
      ss[counter].erase! if(ss[counter].class == Sketchup::Face)
   end

   Sketchup.active_model.commit_operation
end

#----------------------------------------------------------------------------
# add menu items
#if( not $desel_menu_loaded )
#   TBD_menu = UI.menu("Plugins").add_submenu("[TBD] Desel")
#   TBD_menu.add_item("Deselect edges") { desel_func Sketchup::Edge}
#   TBD_menu.add_item("Deselect faces") { desel_func Sketchup::Face}
#   TBD_menu.add_item("Add faces") { add_faces }
#   TBD_menu.add_item("Remove faces") { remove_faces }
#   TBD_menu.add_separator
#   TBD_menu.add_item("About...") { UI.messagebox "Desel 1.o\nby TBD\n\nFor private use only!"}
#end

$desel_menu_loaded = true

