#        Name : project_line_planes
# Description : projects the selected line perpendicular to the selected set of faces
#      Author : Didier Bur
#       Usage : select a line and faces and run the script, you'll get new lines  which are the
#               perpendicular projection of the selected lines on these faces. Additionnal faces 
#               can be created too if you select "yes" in the dialog box.
#        Date : 12.Aug.2oo4
#        Type : tool

require 'sketchup.rb'

def project_line_planes

model = Sketchup.active_model
model.start_operation "Project line on faces"
entities = model.active_entities
ss = model.selection

if ss.empty? 
  UI.messagebox("No selection.")
  return nil
end

#if( ss.length > 2 )
  #UI.messagebox("Please select only a line and a face.")
  #return nil
#end

# Who's the line and who are the faces ?
i = 0
indice_line = 0
line_found = 0
other_found = 0
0.upto(ss.length - 1) do |something|
  element = ss[i]
  if( element.typename == "Edge")
    indice_line = i
    line_found = 1
  end
  if( (element.typename != "Edge") and (element.typename != "Face") )
    other_found = 1
  end  
  i = i + 1
end  #of upto

# Selection errors checking
if( line_found == 0 )
  UI.messagebox("Please select a line too.")
  return nil
end

if( other_found == 1 )
  UI.messagebox("Please select only a line and faces.")
  return nil
end

# let's get the endpoints of the edge
end_pts = []
end_pts = ss[indice_line].vertices
# then remove the edge from the selection set
ss.remove(ss[indice_line])

#This Ruby OOP is too funny ;)

# sets the default projection settings
@create_faces = "No" if not @create_faces

# Dialog box
create_faces = ["Yes","No"]
enums = [create_faces.join("|")]
prompts = ["Create faces  "]
values = [@create_faces]

results = inputbox prompts, values, enums, "Parameters"

# User cancels
return if not results
# Otherwise
@create_faces = results

# let's go for the projection
j = 0
0.upto( ss.length - 1 ) do |something|
  fc = ss[j]
  plan = fc.plane
  new_pt1 = end_pts[0].position.project_to_plane(plan[0], plan[1], plan[2], plan[3])
  new_pt2 = end_pts[1].position.project_to_plane(plan[0], plan[1], plan[2], plan[3])
  Sketchup.active_model.active_entities.add_line( new_pt1, new_pt2 )
  j = j + 1
  
  if(  @create_faces[0] == "Yes" )
    Sketchup.active_model.active_entities.add_face( end_pts[0].position, end_pts[1].position, new_pt2, new_pt1 )
  end
end # of upto

end # of def

#if( not file_loaded?("project_line_planes.rb") )

    # This will add a separator to the menu, but only once
#    add_separator_to_menu("Plugins")
    
    # To add an item to a menu, you identify the menu, and then
    # provide a title to display and a block to execute.  In this case,
    # the block just calls the create_box function
 #   UI.menu("Plugins").add_item("Project a line on faces") { project_line_planes }

#end

#-----------------------------------------------------------------------------
file_loaded("project_line_planes.rb")