#        Name : project_point_line
# Description : projects the selected construction point perpendicular to the selected line
#      Author : Didier Bur
#       Usage : select a cpoint and a line and run the script, you'll get another cpoint on the line which is the perpendicular projection of the selected cpoint on that line.
#        Date : 10.Aug.2oo4
#        Type : tool

require 'sketchup.rb'

def project_point_line

model = Sketchup.active_model
model.start_operation "Project point on line"
entities = model.active_entities
ss = model.selection

if ss.empty? 
  UI.messagebox("No selection.")
  return nil
end


if( not ss[0].kind_of? Sketchup::ConstructionPoint )
    UI.messagebox("Please select a point first.")
    return nil
end

# Who's the line and who's the point ?
ent1 = ss[0]
ent2 = ss[1]
if( ent1.typename == "ConstructionPoint")
  pt = ent1
  ln = ent2
  else
  ln = ent1
  pt = ent2
end

pt1 = ln.vertices[0]
pt2 = ln.vertices[1]
# let's go for the projection
pt_on_line = pt.position.project_to_line([pt1, pt2])
Sketchup.active_model.active_entities.add_cpoint pt_on_line

end

#if( not file_loaded?("project_point_line.rb") )

    # This will add a separator to the menu, but only once
#    add_separator_to_menu("Plugins")
    
    # To add an item to a menu, you identify the menu, and then
    # provide a title to display and a block to execute.  In this case,
    # the block just calls the create_box function
#    UI.menu("Plugins").add_item("Project point on line") { project_point_line }

#end

#-----------------------------------------------------------------------------
file_loaded("project_point_line.rb")