#        Name : project_point_plane
# Description : projects the selected construction point perpendicular to the selected face
#      Author : Didier Bur
#       Usage : select a cpoint and a face and run the script, you'll get another cpoint on the line which is the perpendicular projection of the selected cpoint on that face.
#        Date : 11.Aug.2oo4
#        Type : tool

require 'sketchup.rb'

def project_point_plane

model = Sketchup.active_model
model.start_operation "Project point on face"
entities = model.active_entities
ss = model.selection

if ss.empty? 
  UI.messagebox("No selection.")
  return nil
end


if( not ss[0].kind_of? Sketchup::ConstructionPoint )
    UI.messagebox("Please select a point first.")
    return nil
end

# Who's the face and who's the face ?
ent1 = ss[0]
ent2 = ss[1]
if( ent1.typename == "ConstructionPoint")
  pt = ent1
  fc = ent2
  else
  fc = ent1
  pt = ent2
end

vec = fc.normal.normalize!

# let's go for the projection
#pt_on_plane = pt.position.project_to_plane(pt.position, vec) 

plan = fc.plane

Sketchup.active_model.active_entities.add_cpoint pt.position.project_to_plane(plan[0], plan[1], plan[2], plan[3])
end

#if( not file_loaded?("project_point_plane.rb") )

    # This will add a separator to the menu, but only once
#    add_separator_to_menu("Plugins")
    
    # To add an item to a menu, you identify the menu, and then
    # provide a title to display and a block to execute.  In this case,
    # the block just calls the create_box function
#    UI.menu("Plugins").add_item("Project point on face") { project_point_plane }

#end

#-----------------------------------------------------------------------------
file_loaded("project_point_plane.rb")